"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var formatter_parser_injectionToken_1 = require("./formatter-parser.injectionToken");
var core_1 = require("@angular/core");
var formatterParser_1 = require("./formatterParser");
var FormatterParserService = (function () {
    function FormatterParserService(FORMATTER_PARSER) {
        this.FORMATTER_PARSER = FORMATTER_PARSER;
    }
    FormatterParserService.prototype.getFormatParseFunction = function (functionName, params) {
        var formatParseFunction;
        if (functionName in formatterParser_1.FormatterParser) {
            formatParseFunction = formatterParser_1.FormatterParser[functionName];
        }
        else if (this.FORMATTER_PARSER) {
            formatParseFunction = this.FORMATTER_PARSER.find(function (formParsFunc) {
                return functionName === formParsFunc.name;
            });
        }
        if (!(typeof formatParseFunction === 'function')) {
            throw new Error("Formatter or Parser with name " + functionName + " \n                             is not provided as a function via FormatterParser \n                             service or FORMATTER_PARSER InjectionToken. \n                             Did you forgot to provide them?");
        }
        return (params) ? formatParseFunction.apply(void 0, params) : formatParseFunction;
    };
    return FormatterParserService;
}());
FormatterParserService = __decorate([
    core_1.Injectable(),
    __param(0, core_1.Optional()), __param(0, core_1.Inject(formatter_parser_injectionToken_1.FORMATTER_PARSER))
], FormatterParserService);
exports.FormatterParserService = FormatterParserService;
