"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var FormatterParser = (function () {
    function FormatterParser() {
    }
    FormatterParser.replaceString = function (searchValue, replaceValue) {
        return function (value) {
            var transformedValue = value;
            if (typeof transformedValue === 'string' || transformedValue instanceof String) {
                transformedValue = transformedValue.replace(searchValue, replaceValue);
            }
            var result = {
                name: 'replaceString',
                result: transformedValue,
                previous: value
            };
            return result;
        };
    };
    return FormatterParser;
}());
FormatterParser.toCapitalized = function (value) {
    var transformedValue = value;
    if (typeof value === 'string' || value instanceof String) {
        transformedValue = transformedValue
            .toLowerCase()
            .split(' ')
            .map(function (val) { return val.charAt(0).toUpperCase() + val.slice(1); })
            .join(' ');
    }
    return {
        name: 'toCapitalized',
        result: transformedValue,
        previous: value
    };
};
FormatterParser.toUpperCase = function (value) {
    var transformedValue = value;
    if (typeof value === 'string' || value instanceof String) {
        transformedValue = value.toUpperCase();
    }
    return {
        name: 'toUpperCase',
        result: transformedValue,
        previous: value
    };
};
FormatterParser.toLowerCase = function (value) {
    var transformedValue = value;
    if (typeof transformedValue === 'string' || transformedValue instanceof String) {
        transformedValue = transformedValue.toLowerCase();
    }
    return {
        name: 'toLowerCase',
        result: transformedValue,
        previous: value
    };
};
exports.FormatterParser = FormatterParser;
